

angular.module('app.controllers', [])
  
.controller('homeCtrl', function($scope,$state,$ionicHistory) {

	})
   
.controller('estadistiquesCtrl', ["$scope", "$rootScope", "GestorAssignatures", "$firebaseArray", "$stateParams","$rootScope","Auth", "$state", 
                              function($scope, $rootScope, GestorAssignatures, $firebaseArray,  $stateParams, $rootScope, Auth, $state) {
	//Es cromprova si s'ha fet login	
	if($rootScope.loged){
	//Carrega de les estadístiques de l'usuari
	var EstadistiquesRef = fbref.child("RegistreTrivial/"+$rootScope.authData.uid);
	$scope.estadistiques = $firebaseArray(EstadistiquesRef);
	}else{
	//Cas que no s'hagi fet login, torna al home
		$ionicHistory.clearCache().then(function(nomtema){
		alert("Has de fer login per poder accedir a l'app. ");
		$state.go('menu.home', {}, { reload: true });
        $ionicHistory.nextViewOptions({
  	      disableBack: true
  	    });
		});
	}
}])

   

.controller('assignaturesCtrl', ["$scope","$rootScope", "$firebaseArray","Auth","$state", "$ionicHistory",
                                 function($scope,$rootScope, $firebaseArray, Auth, $state, $ionicHistory) {
	//Es cromprova si s'ha fet login
	if($rootScope.loged){
	//Carrega de les assignatures
	var AssignaturesRef = new Firebase("https://edutrivial.firebaseio.com/Assignatures");
	$scope.assignatures = $firebaseArray(AssignaturesRef);
	}else{
		//Cas que no s'hagi fet login, torna al home
		$ionicHistory.clearCache().then(function(nomtema){
		alert("Has de fer login per poder accedir a l'app. ");
		$state.go('menu.home', {}, { reload: true });
        $ionicHistory.nextViewOptions({
  	      disableBack: true
  	    });
		});
	}
}
])

   
.controller('TemaCtrl', ["$scope", "$firebaseArray","GestorAssignatures", "$stateParams", "GestorAssignatures",
                                 function($scope, $firebaseArray, GestorAssignatures, $stateParams, GestorAssignatures) {
	//Carrega els temes de l'assignatura seleccionada
	$scope.assignaturaSeleccionada = $stateParams.assignaturaId;
	var TemesRef = fbref.child("Temes").orderByChild('Assignatura').equalTo($stateParams.assignaturaId);
	$scope.temes = $firebaseArray(TemesRef);

	//Escriu el nom de l'assignatura i avisa si no hi ha temes
	$scope.temes.$loaded().then(function(numtemes) {
		if (numtemes.length<1){
			$scope.msgnotema="Encara no hi ha temes d'aquesta assignatura ";
		}
		GestorAssignatures.obtenirNomAssignatura($stateParams.assignaturaId).then(function(nomassignatura){
			$scope.NomassignaturaSeleccionada=nomassignatura;
			});
	});
	 
}])

.controller('PreguntesCtrl', ["$scope", "$firebaseArray", "GestorAssignatures","$location", "GestorTemes", "$state", "$stateParams", "$ionicModal","$rootScope","$ionicHistory", 
                              function($scope, $firebaseArray, GestorAssignatures, $location, GestorTemes, $state, $stateParams, $ionicModal,$rootScope,$ionicHistory) {
	//Establiment de paràmetres inicials
	$scope.temaSeleccionat = $stateParams.temaId;
	$scope.assignaturaSeleccionada = $stateParams.assignaturaId;
	$scope.contaPregunta = 0;
	$scope.encerts=0;
	
	//Carrega de les preguntes del tema seleccionat
	var PreguntesRef = fbref.child("Preguntes/"+$stateParams.assignaturaId+"/"+$stateParams.temaId);
	$scope.preguntes = $firebaseArray(PreguntesRef);
	
	//Col·loca el nom del tema a la capçalera
	$scope.preguntes.$loaded().then(function(numpreguntes) {
		$scope.totalPreguntes = numpreguntes.length;
		GestorTemes.obtenirNomTema($stateParams.temaId).then(function(nomtema){
		      $scope.NomTemaSeleccionat=nomtema;
		});
	});
	
    $scope.ComprovaPregunta = function (respostamarcada, respostacorrecta) {
    	//Comprovar si s'ha encertat la pregunta
	
    	if(respostamarcada == respostacorrecta){
    		alert('Correcte!');
    		$scope.encerts++;
    	}else{
    		alert('Incorrecte! La resposta correcta era: '+respostacorrecta);
    	}
    	//Passar a la següent pregunta
    	if( $scope.contaPregunta < $scope.totalPreguntes-1 ){
    		$scope.contaPregunta++;	
    	}
    	//Acabar el joc
    	else{
    		alert('Tema acabat\nEls teus encerts han sigut: '+ $scope.encerts +' de '+$scope.totalPreguntes+' preguntes.') ;
    		var RegistreTrivialRef = fbref.child("RegistreTrivial/"+$rootScope.authData.uid);
    	    GestorAssignatures.obtenirNomAssignatura($stateParams.assignaturaId).then(function(nomassignatura){
    	    	GestorTemes.obtenirNomTema($stateParams.temaId).then(function(nomtema){
    	    	RegistreTrivialRef.push().set({
        			Assignatura: nomassignatura,
        			Tema: nomtema,
        		    Encerts: $scope.encerts,
        		    Data: DataActual()
        		});
    	      });
    	    }).then(function(){
      	      $rootScope.hide();
      	    $ionicHistory.nextViewOptions({
      	      disableBack: true
      	    });
      	    $state.go('menu.home', {}, { reload: true });
    	    });
    	    $ionicHistory.clearCache();
      	    $ionicHistory.nextViewOptions({
        	      disableBack: true
        	    });
    	 $state.go("menu.home"); 
       	}	
    };
    
}])

.controller('loginCtrl', function ($scope, $rootScope, $state, Auth, $firebase, $ionicHistory) {
	//Fer login amb l'usuari
	 $rootScope.authData = {};
	$scope.loginusuari = function (user) {	
		fbref.authWithPassword({
		email    : user.email,
		password : user.password
		}, function(error, authData) {
		  if (error) {
			//el login no és correcte
			  alert('Login incorrecte!\nIntrodueixi Usuari i Password de nou.');
		  } else {
			  //el login és correcte
	          $rootScope.loged=true;
	          alert('Login correcte!');
	          $state.go('menu.home', {}, { reload: true });
	          $ionicHistory.nextViewOptions({
        	      disableBack: true
        	    });
	          $state.go("menu.home");
		  }
		});
	};
});




 