angular.module('app.services', [])

//Retorna el valor de l'autentificació a la base de dades
.factory('Auth', function ($firebaseAuth, $rootScope) {
    return $firebaseAuth(fbref); 
})

        //Funcions de gestió de la base de dades de l'element Assignatures
.factory('GestorAssignatures', function ($firebase, $q, $rootScope, $state, $firebaseAuth, Auth) {
            
            var refAssignatures = fbref.child("Assignatures");

            return {
                
            	refAssignatures: function () {
                    return refAssignatures;
                },
               
                //Retorna el nom de l'assignatura 
                //Cal passar la id de l'assignatura per paràmetre
                obtenirNomAssignatura: function (id) {
                	var deferred = $q.defer();
                	var refAssigantura = refAssignatures.child(id);
                	refAssigantura.once("value", function (snap) {
                		var nomassignatura = snap.child("Nom").val();
                        deferred.resolve(nomassignatura);
                    });
                    return deferred.promise;
                	}
            };
        })
        
        //Funcions de gestió de la base de dades de l'element Temes
.factory('GestorTemes', function ($firebase, $q, $rootScope, $state, $firebaseAuth, Auth) {
	            
            var refTemes = fbref.child("Temes");

            return {
                //Retorna tots els temes
            	refTemes: function () {
                    return refTemes;
                },
                //Retorna el nom del tema
                //Cal passar la id del tema per paràmetre
                obtenirNomTema: function (id) {
                	var deferred = $q.defer();
                	var refTema = refTemes.child(id);
                	refTema.once("value", function (snap) {
                		var nomtema = snap.child("Nom").val();
                        deferred.resolve(nomtema);
                    });
                    return deferred.promise;
                	}
            };
        })


.factory('BlankFactory', [function(){

}]);

//Retorna el mail substituint el '.' per ','
//Entra un mail
function TreurePuntsMail(email) {
    if (!email)
        return false
    email = email.replace(".", ',');
    return email;
}
//Retorna la data actual en format "dd/mm/aaaa"
//NO hi ha paràmetres d'entrada
function DataActual() {
	var today = new Date();
    var dd = today.getDate();
    var mm = today.getMonth()+1;
    var yyyy = today.getFullYear();
    if(dd<10){
        dd='0'+dd
    } 
    if(mm<10){
        mm='0'+mm
    } 
    var today = dd+'/'+mm+'/'+yyyy;
    return today;
}
